diff --git a/target-mips/translate.c b/target-mips/translate.c
index cefccb0..590c2b6 100644
--- a/target-mips/translate.c
+++ b/target-mips/translate.c
@@ -6442,8 +6401,8 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(62, 16):
     case FOP(63, 16):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
@@ -6455,22 +6414,22 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
                 gen_cmp_s(func-48, fp0, fp1, cc);
                 opn = condnames[func-48];
             }
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
         }
         break;
     case FOP(0, 17):
         check_cp1_registers(ctx, fs | ft | fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_add_d, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_add_d(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "add.d";
         optype = BINOP;
@@ -6478,15 +6437,15 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(1, 17):
         check_cp1_registers(ctx, fs | ft | fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_sub_d, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_sub_d(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "sub.d";
         optype = BINOP;
@@ -6494,15 +6453,15 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(2, 17):
         check_cp1_registers(ctx, fs | ft | fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_mul_d, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_mul_d(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "mul.d";
         optype = BINOP;
@@ -6510,15 +6469,15 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(3, 17):
         check_cp1_registers(ctx, fs | ft | fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_div_d, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_div_d(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "div.d";
         optype = BINOP;
@@ -6526,151 +6485,151 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(4, 17):
         check_cp1_registers(ctx, fs | fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_sqrt_d, fp0, fp0);
+            gen_helper_float_sqrt_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "sqrt.d";
         break;
     case FOP(5, 17):
         check_cp1_registers(ctx, fs | fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_abs_d, fp0, fp0);
+            gen_helper_float_abs_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "abs.d";
         break;
     case FOP(6, 17):
         check_cp1_registers(ctx, fs | fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "mov.d";
         break;
     case FOP(7, 17):
         check_cp1_registers(ctx, fs | fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_chs_d, fp0, fp0);
+            gen_helper_float_chs_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "neg.d";
         break;
     case FOP(8, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_roundl_d, fp0, fp0);
+            gen_helper_float_roundl_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "round.l.d";
         break;
     case FOP(9, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_truncl_d, fp0, fp0);
+            gen_helper_float_truncl_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "trunc.l.d";
         break;
     case FOP(10, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_ceill_d, fp0, fp0);
+            gen_helper_float_ceill_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "ceil.l.d";
         break;
     case FOP(11, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_floorl_d, fp0, fp0);
+            gen_helper_float_floorl_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "floor.l.d";
         break;
     case FOP(12, 17):
         check_cp1_registers(ctx, fs);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp64, fs);
-            tcg_gen_helper_1_1(do_float_roundw_d, fp32, fp64);
-            tcg_temp_free(fp64);
+            gen_helper_float_roundw_d(fp32, fp64);
+            tcg_temp_free_i64(fp64);
             gen_store_fpr32(fp32, fd);
-            tcg_temp_free(fp32);
+            tcg_temp_free_i32(fp32);
         }
         opn = "round.w.d";
         break;
     case FOP(13, 17):
         check_cp1_registers(ctx, fs);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp64, fs);
-            tcg_gen_helper_1_1(do_float_truncw_d, fp32, fp64);
-            tcg_temp_free(fp64);
+            gen_helper_float_truncw_d(fp32, fp64);
+            tcg_temp_free_i64(fp64);
             gen_store_fpr32(fp32, fd);
-            tcg_temp_free(fp32);
+            tcg_temp_free_i32(fp32);
         }
         opn = "trunc.w.d";
         break;
     case FOP(14, 17):
         check_cp1_registers(ctx, fs);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp64, fs);
-            tcg_gen_helper_1_1(do_float_ceilw_d, fp32, fp64);
-            tcg_temp_free(fp64);
+            gen_helper_float_ceilw_d(fp32, fp64);
+            tcg_temp_free_i64(fp64);
             gen_store_fpr32(fp32, fd);
-            tcg_temp_free(fp32);
+            tcg_temp_free_i32(fp32);
         }
         opn = "ceil.w.d";
         break;
     case FOP(15, 17):
         check_cp1_registers(ctx, fs);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp64, fs);
-            tcg_gen_helper_1_1(do_float_floorw_d, fp32, fp64);
-            tcg_temp_free(fp64);
+            gen_helper_float_floorw_d(fp32, fp64);
+            tcg_temp_free_i64(fp64);
             gen_store_fpr32(fp32, fd);
-            tcg_temp_free(fp32);
+            tcg_temp_free_i32(fp32);
         }
         opn = "floor.w.d";
         break;
@@ -6681,14 +6640,14 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(18, 17):
         {
             int l1 = gen_new_label();
-            TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I64);
+            TCGv t0 = tcg_temp_new();
+            TCGv_i64 fp0 = tcg_temp_local_new_i64();
 
             gen_load_gpr(t0, ft);
             tcg_gen_brcondi_tl(TCG_COND_NE, t0, 0, l1);
             gen_load_fpr64(ctx, fp0, fs);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
             gen_set_label(l1);
             tcg_temp_free(t0);
         }
@@ -6697,14 +6656,14 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(19, 17):
         {
             int l1 = gen_new_label();
-            TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I64);
+            TCGv t0 = tcg_temp_new();
+            TCGv_i64 fp0 = tcg_temp_local_new_i64();
 
             gen_load_gpr(t0, ft);
             tcg_gen_brcondi_tl(TCG_COND_EQ, t0, 0, l1);
             gen_load_fpr64(ctx, fp0, fs);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
             gen_set_label(l1);
             tcg_temp_free(t0);
         }
@@ -6713,78 +6672,78 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(21, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_recip_d, fp0, fp0);
+            gen_helper_float_recip_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "recip.d";
         break;
     case FOP(22, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_rsqrt_d, fp0, fp0);
+            gen_helper_float_rsqrt_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "rsqrt.d";
         break;
     case FOP(28, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_recip2_d, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_recip2_d(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "recip2.d";
         break;
     case FOP(29, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_recip1_d, fp0, fp0);
+            gen_helper_float_recip1_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "recip1.d";
         break;
     case FOP(30, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_rsqrt1_d, fp0, fp0);
+            gen_helper_float_rsqrt1_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "rsqrt1.d";
         break;
     case FOP(31, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_rsqrt2_d, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_rsqrt2_d(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "rsqrt2.d";
         break;
@@ -6805,8 +6764,8 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(62, 17):
     case FOP(63, 17):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
@@ -6820,190 +6779,190 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
                 gen_cmp_d(func-48, fp0, fp1, cc);
                 opn = condnames[func-48];
             }
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
         }
         break;
     case FOP(32, 17):
         check_cp1_registers(ctx, fs);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp64, fs);
-            tcg_gen_helper_1_1(do_float_cvts_d, fp32, fp64);
-            tcg_temp_free(fp64);
+            gen_helper_float_cvts_d(fp32, fp64);
+            tcg_temp_free_i64(fp64);
             gen_store_fpr32(fp32, fd);
-            tcg_temp_free(fp32);
+            tcg_temp_free_i32(fp32);
         }
         opn = "cvt.s.d";
         break;
     case FOP(36, 17):
         check_cp1_registers(ctx, fs);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp64, fs);
-            tcg_gen_helper_1_1(do_float_cvtw_d, fp32, fp64);
-            tcg_temp_free(fp64);
+            gen_helper_float_cvtw_d(fp32, fp64);
+            tcg_temp_free_i64(fp64);
             gen_store_fpr32(fp32, fd);
-            tcg_temp_free(fp32);
+            tcg_temp_free_i32(fp32);
         }
         opn = "cvt.w.d";
         break;
     case FOP(37, 17):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_cvtl_d, fp0, fp0);
+            gen_helper_float_cvtl_d(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "cvt.l.d";
         break;
     case FOP(32, 20):
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_cvts_w, fp0, fp0);
+            gen_helper_float_cvts_w(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "cvt.s.w";
         break;
     case FOP(33, 20):
         check_cp1_registers(ctx, fd);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr32(fp32, fs);
-            tcg_gen_helper_1_1(do_float_cvtd_w, fp64, fp32);
-            tcg_temp_free(fp32);
+            gen_helper_float_cvtd_w(fp64, fp32);
+            tcg_temp_free_i32(fp32);
             gen_store_fpr64(ctx, fp64, fd);
-            tcg_temp_free(fp64);
+            tcg_temp_free_i64(fp64);
         }
         opn = "cvt.d.w";
         break;
     case FOP(32, 21):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp32 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp64 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i32 fp32 = tcg_temp_new_i32();
+            TCGv_i64 fp64 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp64, fs);
-            tcg_gen_helper_1_1(do_float_cvts_l, fp32, fp64);
-            tcg_temp_free(fp64);
+            gen_helper_float_cvts_l(fp32, fp64);
+            tcg_temp_free_i64(fp64);
             gen_store_fpr32(fp32, fd);
-            tcg_temp_free(fp32);
+            tcg_temp_free_i32(fp32);
         }
         opn = "cvt.s.l";
         break;
     case FOP(33, 21):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_cvtd_l, fp0, fp0);
+            gen_helper_float_cvtd_l(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "cvt.d.l";
         break;
     case FOP(38, 20):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_cvtps_pw, fp0, fp0);
+            gen_helper_float_cvtps_pw(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "cvt.ps.pw";
         break;
     case FOP(0, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_add_ps, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_add_ps(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "add.ps";
         break;
     case FOP(1, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_sub_ps, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_sub_ps(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "sub.ps";
         break;
     case FOP(2, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_mul_ps, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_mul_ps(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "mul.ps";
         break;
     case FOP(5, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_abs_ps, fp0, fp0);
+            gen_helper_float_abs_ps(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "abs.ps";
         break;
     case FOP(6, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "mov.ps";
         break;
     case FOP(7, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_chs_ps, fp0, fp0);
+            gen_helper_float_chs_ps(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "neg.ps";
         break;
@@ -7016,9 +6975,9 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
         check_cp1_64bitmode(ctx);
         {
             int l1 = gen_new_label();
-            TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I32);
-            TCGv fph0 = tcg_temp_local_new(TCG_TYPE_I32);
+            TCGv t0 = tcg_temp_new();
+            TCGv_i32 fp0 = tcg_temp_local_new_i32();
+            TCGv_i32 fph0 = tcg_temp_local_new_i32();
 
             gen_load_gpr(t0, ft);
             tcg_gen_brcondi_tl(TCG_COND_NE, t0, 0, l1);
@@ -7026,8 +6985,8 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
             gen_load_fpr32h(fph0, fs);
             gen_store_fpr32(fp0, fd);
             gen_store_fpr32h(fph0, fd);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fph0);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fph0);
             gen_set_label(l1);
             tcg_temp_free(t0);
         }
@@ -7037,9 +6996,9 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
         check_cp1_64bitmode(ctx);
         {
             int l1 = gen_new_label();
-            TCGv t0 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I32);
-            TCGv fph0 = tcg_temp_local_new(TCG_TYPE_I32);
+            TCGv t0 = tcg_temp_new();
+            TCGv_i32 fp0 = tcg_temp_local_new_i32();
+            TCGv_i32 fph0 = tcg_temp_local_new_i32();
 
             gen_load_gpr(t0, ft);
             tcg_gen_brcondi_tl(TCG_COND_EQ, t0, 0, l1);
@@ -7047,8 +7006,8 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
             gen_load_fpr32h(fph0, fs);
             gen_store_fpr32(fp0, fd);
             gen_store_fpr32h(fph0, fd);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fph0);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fph0);
             gen_set_label(l1);
             tcg_temp_free(t0);
         }
